/*
 *
 *  program     : tag2html
 *  version     : 0.1.1
 *  copyright   : (C) 2003 by ringostarr / sfo
 *  email       : ringostarr <ringo19@gmx.de>
 *                sfo <sfo@zapo.net>
 *  resource	: http://tag2html.sourceforge.net
 *
 *
 *
 *  This file is part of tag2html.
 *
 *  tag2html is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  tag2html is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with tag2html; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include "./main.h"

int main( int argc, char *argv[ ] )
{
	// pruefen der kommandozeilen-argumente...
	if( argc != 2 ) // pruefen ob anzahl der argumente ok
	{
		cout << "usage: " << argv[ 0 ] << " [output-filetype]" << endl
		     << "       [ouput-filetype]    --html   writes all information to an HTML file." << endl
		     << "                           --php    writes all information to a PHP file." << endl
		     << "                           --xml    writes all information to a XML file." << endl << endl;
		exit( -1 );
	}

	cout << "Starting tag2html v-0.1.1..." << endl
	     << "Copyright (C) 2003 by:  ringostarr <ringo19@gmx.de>" << endl
	     << "                        sfo <sfo@zapo.net>" << endl << endl
	     << "report bugs, hints and criticism to one of the email" << endl
	     << "addresses mentioned above! for updates and new" << endl
	     << "releases visit: http://tag2html.sourceforge.net" << endl << endl;

	// klassen erstellen...
	tags *mytag = new tags;
	html *myhtml = new html;
	header *myheader = new header;
	header *statheader = new header;
	mp3_sort *mysort = new mp3_sort;
	stats *mystat = new stats;

	// structs
	DIR *mydir;
	struct dirent *mydirent;

	char dir[ 1024 ];

	mytag->layout_flag = 1;
	mytag->trackno = 0;

	if( !strcmp( argv[ 1 ], "--php" ) )
		myhtml->use_php = true;

	if( myhtml->use_php == false )
	{
		strncpy( myhtml->htmlfilename, "./index.html", sizeof( myhtml->htmlfilename ) );
		strncpy( myhtml->statfilename, "./stats.html", sizeof( myhtml->statfilename ) );
		strncpy( myhtml->infofilename, "./info.html", sizeof( myhtml->infofilename ) );
	}
	else
	{
		strncpy( myhtml->htmlfilename, "./index.php", sizeof( myhtml->htmlfilename ) );
		strncpy( myhtml->statfilename, "./stats.php", sizeof( myhtml->statfilename ) );
		strncpy( myhtml->infofilename, "./info.php", sizeof( myhtml->infofilename ) );
	}

	if( ( mydir = opendir( getcwd( dir, 1024 ) ) ) == NULL )
	{
		cerr << "err: can't open current directory to read contents!" << endl;
		exit( -1 );
	}

	if( !strcmp( argv[ 1 ], "--html" ) )
	{
		cout << "creating file " << dir << "/index.html" << endl;
		if( html_head( myhtml, mytag ) == -1 )
		{
			cerr << "err: can't open html-file!" << endl;
			exit( -1 );
		}

		if( stat_head( myhtml ) == -1 )
		{
			cerr << "err: can't open stat-file!" << endl;
			exit( -1 );
		}
		
		if( info_head( myhtml->infofilename ) == -1 )
		{
			cerr << "err: can't open info-file!" << endl;
			exit( -1 );
		}
	}

	if( !strcmp( argv[ 1 ], "--php" ) )
	{
		cout << "creating file " << dir << "/index.php" << endl;
		if( html_head( myhtml, mytag ) == -1 )
		{
			cerr << "err: can't open php-file!" << endl;
			exit( -1 );
		}

		if( stat_head( myhtml ) == -1 )
		{
			cerr << "err: can't open stat-file!" << endl;
			exit( -1 );
		}           
		
		if( info_head( myhtml->infofilename ) == -1 )
		{
			cerr << "err: can't open info-file!" << endl;
			exit( -1 );
		}
	}

	if( !strcmp( argv[ 1 ], "--xml" ) )
	{
		cout << "creating file " << dir << "/index.xml" << endl;
		if( xml_head( "./index.xml" ) == -1 )
		{
			cerr << "err: can't open xml-file!" << endl;
			exit( -1 );
		}
	}

	cout << "searching for mp3-files in  " << dir << "/" << endl;

	while( ( mydirent = readdir( mydir ) ) != NULL )
	{
		if( strstr( mydirent->d_name, ".mp3" ) != NULL )
		{
			mysort->cur_index++;
			mystat->mp3_count++;

			get_mp3tags( mydirent->d_name, mytag );
			mystat->tot_filesize += get_filesize( mydirent->d_name );
			get_albumcount( mytag->album, mystat );
			get_artistcount( mytag->artist, mystat );

			get_mp3header( mydirent->d_name, myheader );
			statheader->Length += myheader->Length;
			get_mp3time( myheader->Length, myheader );
			strncpy( mytag->filename, mydirent->d_name, sizeof( mytag->filename ) );
			strncpy( mytag->length, myheader->Length_String,
					sizeof( mytag->length ) );

			mysort->make_array( mytag );

			switch( mytag->layout_flag )
			{
				case 0: mytag->layout_flag = 1; break;
				case 1: mytag->layout_flag = 0; break;
			}
		}
	}

	get_mp3time( statheader->Length, statheader );
	strncpy( mystat->tot_length, statheader->Length_String, sizeof( mystat->tot_length ) );
	mysort->sort_tag( );

	for( int i=0; i<=mysort->cur_index; i++ )
	{
		if( !strcmp( argv[ 1 ], "--html" ) )
		{
			if( html_content( &mysort->s_tag[ i ], myhtml ) == -1 )
			{
                               	cerr << "err: can't open html-file!" << endl;
				exit( -1 );
			}
			
			if( info_body( myhtml->infofilename, myheader, &mysort->s_tag[ i ] ) == -1 )
			{
				cerr << "err: can't open html-file!" << endl;
				exit( -1 );
			}
		}

		if( !strcmp( argv[ 1 ], "--php" ) )
		{
			if( html_content( &mysort->s_tag[ i ], myhtml ) == -1 )
			{
				cerr << "err: can't open php-file!" << endl;
				exit( -1 );
			}

			if( info_body( myhtml->infofilename, myheader, &mysort->s_tag[ i ] ) == -1 )
			{
				cerr << "err: can't open php-file!" << endl;
				exit( -1 );
			}
		}

		if( !strcmp( argv[ 1 ], "--xml" ) )
		{
			if( xml_content( &mysort->s_tag[ i ], "./index.xml" ) == -1 )
			{
				cerr << "err: can't open xml-file!" << endl;
				exit( -1 );
			}
		}
	}

	if( !strcmp( argv[ 1 ], "--html" ) )
	{
		if( html_foot( myhtml ) == -1 )
		{
			cerr << "err: can't open html-file!" << endl;
			exit( -1 );
		}                    
		
		cout << "data successfully written to " << dir << "/index.html" << endl;

		if( stat_content( mystat, myhtml ) == -1 )
		{
			cerr << "err: can't open stat-file!" << endl;
			exit( -1 );
		}

		if( stat_foot( myhtml ) == -1 )
		{
			cerr << "err: can't open stat-file!" << endl;
			exit( -1 );
		}
		
		if( info_foot( myhtml->infofilename ) == -1 )
		{
			cerr << "err: can't open info-file!" << endl;
			exit( -1 );
		}
	}

	if( !strcmp( argv[ 1 ], "--php" ) )
	{
		if( html_foot( myhtml ) == -1 )
		{
			cerr << "err: can't open php-file!" << endl;
			exit( -1 );
		}
		cout << "data successfully written to " << dir << "/index.php" << endl;

		if( stat_content( mystat, myhtml ) == -1 )
		{
			cerr << "err: can't open stat-file!" << endl;
			exit( -1 );
		}

		if( stat_foot( myhtml ) == -1 )
		{
			cerr << "err: can't open stat-file!" << endl;
			exit( -1 );
		}
		
		if( info_foot( myhtml->infofilename ) == -1 )
		{
			cerr << "err: can't open info-file!" << endl;
			exit( -1 );
		}
	}

	if( !strcmp( argv[ 1 ], "--xml" ) )
	{
		if( xml_foot( "./index.xml" ) == -1 )
		{
			cerr << "err: can't open xml-file!" << endl;
			exit( -1 );
		}
		cout << "data successfully written to " << dir << "/index.xml" << endl;
	}

	delete mytag;
	delete myhtml;
	delete myheader;
	delete mysort;
	delete mystat;
	delete statheader;

	exit( 0 );
}
