/*
 *
 *  program     : tag2html
 *  version     : 0.1.1
 *  copyright   : (C) 2003 by ringostarr / sfo
 *  email       : ringostarr <ringo19@gmx.de>
 *                sfo <sfo@zapo.net>
 *  resource	: http://tag2html.sourceforge.net
 *
 *
 *
 *  This file is part of tag2html.
 *
 *  tag2html is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  tag2html is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with tag2html; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

void tag_kuerzen(char* tag, int zeichenanzahl)
{
  for(int i=zeichenanzahl; i>0; i--)
  {
    if(tag[i]!=' ')
    {
      tag[i+1]='\0';
      i=0;
    }
  }
}

int get_mp3tags(char *filename_ptr, tags *mp3tags)
{
  ifstream mp3_datei;

  mp3_datei.open(filename_ptr, ios::in);
  if(!mp3_datei)
  {
    cerr << "err: could not open '" << filename_ptr << "' to read tags!" << endl;
    return -1;
  } else

  // ans Ende der Datei gehen!
  mp3_datei.seekg(-128, ios::end);

  // berprfen ob TAG gesetzt ist!
  for(int i=0; i<=2; i++)
  {
    mp3_datei.get(mp3tags->TAG[i]);
  }
  if(mp3tags->TAG[0]=='T' && mp3tags->TAG[1]=='A' && mp3tags->TAG[2]=='G')
  {
    // Titel
    for(int i=0; i<=29; i++)
    {
      mp3_datei.get(mp3tags->title[i]);
    }
    tag_kuerzen(mp3tags->title, 29);

    // Artist
    for(int i=0; i<=29; i++)
    {
      mp3_datei.get(mp3tags->artist[i]);
    }
    tag_kuerzen(mp3tags->artist, 29);

    // Album
    for(int i=0; i<=29; i++)
    {
      mp3_datei.get(mp3tags->album[i]);
    }
    tag_kuerzen(mp3tags->album, 29);

    // Jahr
    for(int i=0; i<=3; i++)
    {
      mp3_datei.get(mp3tags->year[i]);
    }

    // Kommentar
    for(int i=0; i<=29; i++)
    {
      mp3_datei.get(mp3tags->comment[i]);
    }
    tag_kuerzen(mp3tags->comment, 27);

    // Tracknummer, nur wenn vorletztes Zeichen des Kommentars leer ist!
    if(mp3tags->comment[26]==' ')
    {
      mp3tags->trackno=mp3tags->comment[29]; // wenn 0, dann unbekannt!
    }

    // Genre
    mp3tags->genre=mp3_datei.get();
  } else
  {
    cout << endl << "no mp3v1-TAGS found!" << endl;
  }

  return 0;
}
