/*
 *
 *  program     : tag2html
 *  version     : 0.1.1
 *  copyright   : (C) 2003 by ringostarr / sfo
 *  email       : ringostarr <ringo19@gmx.de>
 *                sfo <sfo@zapo.net>
 *  resource	: http://tag2html.sourceforge.net
 *
 *
 *
 *  This file is part of tag2html.
 *
 *  tag2html is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  tag2html is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with tag2html; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
 
int xml_head( char *filename )
{
	ofstream out( filename );
	
	if( !out.is_open( ) )
		return -1;
		
	out << "<?xml version=\"1.0\" encoding=\"ISO-8859-1\" ?>" << endl
	    << "<tag-info>" << endl;
	    
	out.close( );
	return 0;
}

int xml_content( tags *tagger, char *filename )
{
	ofstream out( filename, ios::app );
	
	if( !out.is_open( ) )
		return -1;
		
	out << "<track>" << tagger->trackno << "</track>" << endl
	    << "<artist>" << tagger->artist << "</artist>" << endl
	    << "<mp3title>" << tagger->title << "</mp3title>" << endl
	    << "<album>" << tagger->album << "</album>" << endl
	    << "<year>" << tagger->year << "</year>" << endl
	    << "<genre>" << genre_string[ tagger->genre ] << "</genre>" << endl
	    << "<comment>" << tagger->comment << "</comment>" << endl
	    << "<length>" << tagger->length << "</length>" << endl
	    << "<filename>" << tagger->filename << "</filename>" << endl;
	
	out.close( );
	return 0;
}

int xml_foot( char *filename )
{
	ofstream out( filename, ios::app );
	
	if( !out.is_open( ) )
		return -1;
		
	out << "</tag-info>" << endl;
	
	out.close( );
	return 0;
}
